#ifndef _DBUTILS_DAQAPPMGR_CONFIGUREDAPPLICATIONTYPES_H
#define _DBUTILS_DAQAPPMGR_CONFIGUREDAPPLICATIONTYPES_H

#include <DatabaseUtils/DAQAppMgr/ApplicationType.h>
#include <boost/shared_ptr.hpp>
#include <string>
#include <vector>

namespace dbutils {
namespace daqappmgr {

/**
 * Container class for the full set of application
 * types that are run in the DAQ system.
 *
 * @author Kurt Biery
 * @version $Revision: 1.2 $ $Date: 2012/05/30 14:27:44 $
 */

class ConfiguredApplicationTypes {

 public:

    // ********************
    // *** Constructors ***
    // ********************

    ConfiguredApplicationTypes(const std::string& detectorName,
                               int partitionNumber = 0,
                               const bool& useDBData = false);

    // *****************
    // *** Accessors ***
    // *****************

    bool hasValidData() const {return _hasValidData;}

    boost::shared_ptr<ApplicationType>
        getTypeByName(const std::string& typeName) const;

    // temporary modifier

    void _addApplicationType(boost::shared_ptr<ApplicationType> appType);

 private:

    //bool _fetchTypeData(const std::string& tableDefinitionFilename,
    //                    const std::string& detectorName);

    bool _hasValidData;

    std::vector<boost::shared_ptr<ApplicationType> > _typeList;
};

};  // end of namespace daqappmgr
};  // end of namespace dbutils

#endif
